mysite/forum/urls.py
from django.urls import path
from . import views

app_name = 'forum'
urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path('tema/<int:pk>/', views.TemaView.as_view(), name='tema'),
    path('tema/buscar/', views.BuscaView.as_view(), name='busca'),
    path(
        'tema/adicionar/',
        views.NovoTemaView.as_view(), name='add_tema'
    ),
    path(
        'tema/<int:pk>/remover/',
        views.RemoveTemaView.as_view(), name='remove_tema'
    ),
    path(
        'tema/<int:pk>/alterar/',
        views.AlteraTemaView.as_view(), name='altera_tema'
    ),
    path(
        'usuario/adicionar/',
        views.NovoUsuarioView.as_view(), name='add_usuario'
    ),
    path(
        'tema/<int:pk>/perguntar/',
        views.NovaPerguntaView.as_view(), name='add_perg'
    ),
    path(
        'pergunta/<int:pk>/responder/',
        views.AdicionaRespostaView.as_view(), name='add_resp'
    ),
    path(
        'resposta/<int:pk>/votar/',
        views.VotarEmRespostaView.as_view(), name='vota_resp'
    ),
]

mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('raiz.urls')),
    path('enquetes/', include('enquetes.urls')),
    path('forum/', include('forum.urls')),
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
]

mysite/raiz/urls.py
from django.urls import path
from . import views

app_name = 'raiz'
urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
]

mysite/forum/models.py
from django.db import models
from django.forms import ModelForm
from django.contrib.auth.models import User

class Usuario(models.Model):
    user = models.OneToOneField(User, on_delete = models.CASCADE, null = True)
    apelido = models.CharField(max_length = 20)
    ultima_postagem = models.DateTimeField()
    def __str__(self):
        return self.apelido
    class Meta:
        ordering = ['apelido']
        verbose_name = 'Usuário'
        verbose_name_plural = 'Usuários'

class Tema(models.Model):
    titulo = models.CharField(max_length = 100)
    descricao = models.CharField(max_length = 200)
    arquivado = models.BooleanField(default = False)
    imagem = models.ImageField(upload_to='tema', null=True, blank=True)
    data = models.DateField(auto_now_add = True)
    usuario = models.ForeignKey(Usuario, on_delete=models.SET_NULL, null=True)
    def __str__(self):
        return self.titulo

class TemaForm(ModelForm):
    class Meta:
        model = Tema
        fields = ['titulo', 'descricao', 'imagem']

class Pergunta(models.Model):
    enunciado = models.CharField(max_length = 100)
    data = models.DateField(auto_now_add = True)
    curtidas = models.IntegerField(default = 0)
    tema = models.ForeignKey(Tema, on_delete = models.CASCADE)
    usuario = models.ForeignKey(Usuario, on_delete=models.SET_NULL, null=True)
    def get_respostas(self):
        return self.resposta_set.order_by('-curtidas')
    def __str__(self):
        return self.enunciado

class Resposta(models.Model):
    texto = models.CharField(max_length = 100)
    data = models.DateTimeField(auto_now_add = True)
    curtidas = models.IntegerField(default = 0)
    pergunta = models.ForeignKey(Pergunta, on_delete = models.CASCADE)
    usuario = models.ForeignKey(Usuario, on_delete=models.SET_NULL, null=True)
    def __str__(self):
        return self.texto

"""
Ilustração de mapeamento de relacionamento muitos-para-muitos

class Usuario(models.Model):
    apelido = models.CharField(max_length = 20)
    ultima_postagem = models.DateTimeField()
    grupos = models.ManyToManyField(Grupo)

class Grupo(models.Model):
    nome = models.CharField(max_length = 30)

"""

mysite/forum/views.py
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.shortcuts import render, get_object_or_404
from django.utils import timezone
from django.utils.decorators import method_decorator
from django.contrib.auth.decorators import user_passes_test
from django.contrib.auth import login
from django.views import View
from django.contrib import messages
from .models import Tema, TemaForm, Pergunta, Resposta, Usuario
from django.contrib.auth.models import User

class IndexView(View):
    def get(self, request, *args, **kwargs):
        temas = Tema.objects.all()
        contexto = {'temas': temas}
        return render(request, 'forum/index.html', contexto)

class BuscaView(View):
    def post(self, request, *args, **kwargs):
        busca = request.POST.get('busca')
        termo = request.POST.get('termo')
        if busca and termo:
            if busca == 'tema':
                filtro = 'Temas com "%s" no título' % termo
                retorno = Tema.objects.filter(titulo__icontains=termo)
            else:
                filtro = 'Temas com "%s" no texto de perguntas' % termo
                retorno = Tema.objects.filter(
                    pergunta__enunciado__icontains=termo
                ).distinct()
            contexto = {'temas': retorno, 'busca': True, 'filtro': filtro}
            return render(request, 'forum/index.html', contexto)
        else:
            return HttpResponseRedirect(reverse('forum:index'))

class TemaView(View):
    def get(self, request, *args, **kwargs):
        tema = get_object_or_404(Tema, pk=kwargs['pk'])
        usuario_valido = hasattr(request.user, 'usuario')
        contexto = {'tema': tema, 'usuario_valido': usuario_valido}
        return render(request, 'forum/tema.html', contexto)

class NovoUsuarioView(View):
    def get(self, request, *args, **kwargs):
        return render(request, 'forum/novo_usuario.html')
    def post(self, request, *args, **kwargs):
        username = request.POST.get('login')
        senha1 = request.POST.get('senha1')
        senha2 = request.POST.get('senha2')
        email = request.POST.get('email')
        apelido = request.POST.get('apelido')
        if username and senha1 and email and apelido and senha1 == senha2:
            user = User.objects.create_user(username, email, senha1)
            agora = timezone.now()
            usuario = Usuario(user=user, apelido=apelido, ultima_postagem=agora)
            usuario.save()
            login(request, user)
            return HttpResponseRedirect(reverse('forum:index'))
        else:
            contexto = {
                'erro': 'Os campos não podem ficar em branco.'
            }
            return render(request, 'forum/novo_usuario.html', contexto)

def testa_usuario_valido(user):
    if hasattr(user, 'usuario'):
        return True
    return False

@method_decorator(user_passes_test(testa_usuario_valido), name='dispatch')
class NovoTemaView(View):
    def get(self, request, *args, **kwargs):
        form = TemaForm()
        return render(request, 'forum/novo_tema.html', {'form': form})
    def post(self, request, *args, **kwargs):
        form = TemaForm(request.POST, request.FILES)
        if form.is_valid():
            usr = request.user.usuario
            tema = form.save(commit=False)
            tema.usuario = usr
            tema.save()
            messages.success(request,'Tema adicionado com sucesso.')
            return HttpResponseRedirect(reverse('forum:index'))
        else:
            return render(request, 'forum/novo_tema.html', {'form': form})

@method_decorator(user_passes_test(testa_usuario_valido), name='dispatch')
class AlteraTemaView(View):
    def get(self, request, *args, **kwargs):
        tema = get_object_or_404(Tema, pk=kwargs['pk'])
        if not request.user == tema.usuario.user:
            return HttpResponseRedirect(reverse('forum:index'))
        form = TemaForm(instance=tema)
        contexto = {'form': form, 'alteracao': True, 'pk': tema.id}
        return render(request, 'forum/novo_tema.html', contexto)
    def post(self, request, *args, **kwargs):
        tema = get_object_or_404(Tema, pk=kwargs['pk'])
        if not request.user == tema.usuario.user:
            return HttpResponseRedirect(reverse('forum:index'))
        form = TemaForm(request.POST, request.FILES, instance=tema)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect(reverse('forum:index'))
        else:
            contexto = {'form': form, 'alteracao': True, 'pk': tema.id}
            return render(request, 'forum/novo_tema.html', contexto)

@method_decorator(user_passes_test(testa_usuario_valido), name='dispatch')
class RemoveTemaView(View):
    def get(self, request, *args, **kwargs):
        tema = get_object_or_404(Tema, pk=kwargs['pk'])
        tema.delete()
        messages.warning(request, 'Tema %s removido com sucesso'%tema.titulo)
        return HttpResponseRedirect(reverse('forum:index'))

@method_decorator(user_passes_test(testa_usuario_valido), name='dispatch')
class NovaPerguntaView(View):
    def post(self, request, *args, **kwargs):
        tema = get_object_or_404(Tema, pk=kwargs['pk'])
        enunciado = request.POST.get('enunciado')
        if enunciado:
            usr = request.user.usuario
            nova = Pergunta(enunciado=enunciado, tema=tema, usuario=usr)
            nova.save()
            return HttpResponseRedirect(reverse('forum:tema', args=(tema.id,)))
        else:
            contexto = {
                'tema': tema,
                'erro': 'Preencha o enunciado da pergunta corretamente!'
            }
            return render(request, 'forum/tema.html', contexto)

@method_decorator(user_passes_test(testa_usuario_valido), name='dispatch')
class AdicionaRespostaView(View):
    def post(self, request, *args, **kwargs):
        perg = get_object_or_404(Pergunta, pk=kwargs['pk'])
        txt = request.POST['texto']
        if txt:
            usr = request.user.usuario
            resposta = Resposta(
                texto=txt, pergunta=perg, usuario=usr
            )
            resposta.save()
            return HttpResponseRedirect(reverse(
                'forum:tema', args=(perg.tema.id,)
            ))
        else:
            contexto = {
                'tema': perg.tema,
                'erro': 'Digite uma resposta válida!'
            }
            return render(request, 'forum/tema.html', contexto)

class VotarEmRespostaView(View):
    def get(self, request, *args, **kwargs):
        resposta = get_object_or_404(Resposta, pk=kwargs['pk'])
        resposta.curtidas += 1
        resposta.save()
        return HttpResponseRedirect(reverse(
            'forum:tema', args=(resposta.pergunta.tema.id,)
        ))

mysite/forum/templates/forum/base.html
<html>
    <head>
        <title>App Fórum</title>
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
        <meta name="viewport" content="width=device-width, initial-scale=1">
    </head>
    <body>
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
        <h1>Aplicação de Fórum</h1>
        <h2>{% block titulo %}Lista dos Temas Cadastrados{% endblock %}</h2>
        {% if messages %}
           {% for msg in messages %}
              <div class="alert alert-{{ msg.level_tag }}" role="alert">
                  {{ msg.message }}
              </div>
           {% endfor %}
        {% endif %}
        {% block principal %}
        {% endblock %}
        <hr/>
        {% block menu %}
        <a href="{% url 'raiz:index' %}">Lista de Aplicações</a>
        | <a href="{% url 'forum:index' %}">Fórum</a>
        | <a href="{% url 'forum:add_tema' %}">Novo tema</a>
        {% if user.is_authenticated %}
            | Usuário: {{ user.username }}
            (<a href="{% url 'logout' %}?next={{ request.path }}">Logout</a>)
        {% else %}
            | <a href="{% url 'login' %}?next={{ request.path }}">Fazer login</a>
        {% endif %}
        {% endblock %}
    </body>
</html>

mysite/forum/templates/forum/index.html
{% extends 'forum/base.html' %}

{% block titulo %}Lista dos Temas Cadastrados{% endblock %}

{% block principal %}
    <hr/>
    <form method="post" action="{% url 'forum:busca' %}">
        {% csrf_token %}
        Pesquise por
        <input type="radio" name="busca" value="tema" checked/> título dos temas ou
        <input type="radio" name="busca" value="pergunta"/> texto das perguntas:<br/>
        <input type="text" name="termo"/>
        <input type="submit" value="Pesquisar"/>
    </form>
    <hr/>
    {% if temas %}
        <ul>
        {% for tema in temas %}
            <li>Tema {{ forloop.counter }}: <a href="{% url 'forum:tema' tema.id %}">
                {{ tema.titulo }}</a><br/>
                <b><u>Descrição</u></b>: {{ tema.descricao }}<br/>
                <b><u>Autor</u></b>: {{ tema.usuario.apelido }}
                ({{ tema.usuario.user.username }}) <br/>
                {% if tema.usuario.user == user %}
                    <b><u>Operações</u></b>: (tema criado por você)
                    <a href="{% url 'forum:altera_tema' tema.id %}">alterar tema</a> |
                    <a href="{% url 'forum:remove_tema' tema.id %}">remover tema</a>
                {% endif %}
            </li><br/>
        {% endfor %}
        </ul>
    {% elif busca %}
        <h3>Nenhum tema segundo o critério especificado!</h3>
    {% else %}
        <h3>Nenhum tema cadastrado até o momento!</h3>
    {% endif %}
    {% if busca %}
        <u>Filtro</u>: {{ filtro }} (<a href="{% url 'forum:index' %}">remover</a>)
    {% endif %}
{% endblock %}

mysite/forum/templates/forum/novo_tema.html
{% extends 'forum/base.html' %}

{% block titulo %}Cadastramento de Novo Tema{% endblock %}

{% block principal %}
    {% if form.error %}
        <hr/>
        <b>{{ form.error }}</b>
        <hr/>
    {% endif %}
    <form method="post" enctype="multipart/form-data"
        {% if alteracao %}
            action="{% url 'forum:altera_tema' pk  %}"
        {% else %}
            action="{% url 'forum:add_tema' %}"{% endif %}>
        {% csrf_token %}
        {{ form.as_p }}
        <input type="submit" value={% if alteracao %}"Atualizar registro"
        {% else %}"Efetuar o cadastro"{% endif %}/>
    </form>
{% endblock %}

mysite/forum/templates/forum/novo_usuario.html
{% extends 'forum/base.html' %}

{% block titulo %}Cadastramento de Usuário{% endblock %}

{% block principal %}
    {% if erro %}
        <hr/>
        <b>{{ erro }}</b>
        <hr/>
    {% endif %}
    <form method="post" action="{% url 'forum:add_usuario' %}">
        {% csrf_token %}
        <p>Apelido: <input type="text" name="apelido"></p>
        <p>Login: <input type="text" name="login"/></p>
        <p>E-mail: <input type="text" name="email"></p>
        <p>Senha: <input type="password" name="senha1"></p>
        <p>Confirmação de senha: <input type="password" name="senha2"></p>

        <input type="submit" value="Efetuar o cadastro"/>
    </form>
{% endblock %}

mysite/forum/templates/forum/tema.html
{% extends 'forum/base.html' %}

{% block titulo %}Tema: {{ tema.titulo }}{% endblock %}

{% block principal %}
    <p><b><u>Descrição</u></b>: {{ tema.descricao }}</p>
    {% if tema.imagem %}
        <img src="{{ tema.imagem.url }}" width="250"/><br/>
    {% endif %}
    {% if erro %}
        <hr/>
        <b>{{ erro }}</b>
        <hr/>
    {% endif %}

    <h3>Lista das Perguntas e Respostas</h3>
    {% if tema.pergunta_set.count > 0 %}
        {% for pergunta in tema.pergunta_set.all %}
            <hr/>
            [PERGUNTA {{ forloop.counter }}] <b>{{ pergunta.enunciado }}</b><br/>
            {% if pergunta.resposta_set.count == 0 %}
                <dd>Nenhuma resposta cadastrada. <b>Responda, se souber!</b></dd>
            {% endif %}
            {% for resposta in pergunta.get_respostas %}
                <dd>
                [RESPOSTA {{ forloop.counter }}]:
                {{ resposta.texto }} (por {{ resposta.usuario.apelido }})
                [{{ resposta.curtidas }}]
                <a href="{% url 'forum:vota_resp' resposta.id %}">+1</a>
                </dd>
            {% endfor %}
            {% if user.is_authenticated and usuario_valido %}
                <br/>Responda você também a essa pergunta:<br/>
                <form method="post"
                      action="{% url 'forum:add_resp' pergunta.id %}">
                    {% csrf_token %}
                    <textarea name="texto" cols="40"></textarea><br/>
                    <input type="submit" value="Cadastrar Resposta"/>
                </form>
            {% endif %}
        {% endfor %}
    {% else %}
        <b>Ainda não há nenhuma pergunta cadastrada!</b>
    {% endif %}

    {% if user.is_authenticated and usuario_valido %}
        <hr/>
        <h3>Cadastre uma Nova Pergunta</h3>
        <form method="post" action="{% url 'forum:add_perg' tema.id %}">
            {% csrf_token %}
            <p>Enunciado: <input type="text" name="enunciado" size="60"/></p>
            <input type="submit" value="Cadastrar Pergunta"/>
        </form>
    {% endif %}
{% endblock %}